
<h2>Overview</h2>

<p>This module contains scripts and tools that are used to create an
installation CD for the 'scarlet' gateway/router.</p>

<p>There are two different ways for installing the router. One of them
is more flexible and <em>professional</em>, similar to the
installation of Slackware itself. The second one is not so flexible,
but very simple and easy, suitable for <em>dummy</em> (or not so
technical) people.</p>

<p>The workflow of preparing installation CDs is like this:</p>

<ul>

  <li>Initially I have installed a slackware system, trying to make it
  as small as possible (installing as few packages as possible, but
  trying to include the required ones, like php, mysql, etc.)</li>

  <li>Then the application is installed and configured manually. In
  the effort to make it work, other slackware packages are installed
  as well, which are required by apache, php, mysql, etc. Some
  configuration files are modified as well and these modifications are
  recorded in the installation/configuration scripts of the
  application itself, so that next time they are done more
  easily.</li>

  <li>When everything works and is tested, a list of installed
  packages is taken in order to create the professional installation
  CD.  A slackware package for the application (called scarlet) is
  created as well, in order to install it automatically.</li>

  <li>Then the slackware first installation CD is modified and an
  installation CD for the router is created. This is done with the
  help of some scripts, using the list of the installed packages as
  well. The main advantage of this installation CD over the slackware
  installation CD is that the right packages to be installed are
  selected by default, and no time should be spent to select them, to
  solve dependencies, etc. This installation CD preserves also the
  flexibility of the original slackware CD. On the other hand, not
  everything can be done automatically and it still needs some manual
  intervention from a professional person in order to make everything
  work.</li>

  <li>After the system that is installed using the professional CD is
  fixed and tested and is known to work well, the work for preparing
  an easier installation CD can start. It is done by making a physical
  copy of the harddisk of this system, writing it on an installation
  CD and from the CD copying it to a new blank harddisk. So the new
  harddisk will be an identical physical copy of the original one.
  This reduces the flexibility of the installation, there is nothing
  to choose and nothing can be modified on the installed system,
  however it has the advantage of the simplicity, and the installation
  can be done even by non-technical people.</li>

</ul>


<h2>The Professional Installation CD</h2>

<p>The <em>professional</em> installation CD of the router is just a
modified version of the Slackware first installation CD. The
modifications that are done are these:</p>

<ul>

  <li>A slackware package for the installation of the web application
  is included in the CD.</li>

  <li>The installation scripts are modified a bit so that the packages
  that are installed by default are a minimum subset of the slackware
  packages, but the dependencies of the web application are included
  (the packages that are needed so that the web application works, or
  that may be usefull/helpfull).</li>

  <li>The installation scripts are modified a bit so that some things
  are done automatically. E.g when the best choice is obvious, it is
  selected automaticly instead of prompting the user with a choice
  list.<br/>

  Note: This kind of automation is not implemented yet, and maybe it
  is not needed after all, because it goes against the flexibility.</li>

</ul>

<p>For a general guide/tutorial about modifying the Slackware
distribution look at this link: <a
href="http://www.linuxquestions.org/linux/answers/Applications_GUI_Multimedia/Cooking_Up_Some_Slack_CUSS"
target="_blank">Cooking Up Some Slack CUSS</a>
</p> 

<p>The installation is done in a very similar way to the installation
of Slackware itself: boot from the CD, partition the harddisk with
<strong>cfdisk</strong> (creating a swap partition and a root
partition), start installation running <strong>setup</strong>,
etc. During installation the same steps are followed as for the
installation of Slackware itself. The difference is that the packages
that are suggested for installation are the right packages (a small
set of packages, which includes the required and the suggested
ones). Besides, the scarlet package is installed as well. So, if all
the default setting are selected and nothing is changed, the installed
system would be OK.</p>

<p>But the scarlet installation/configuration program has to be called
manually by the system admin (root). And also any small thing needs to
be fixed. This is why it is called professional. The default settings
of setup can be changed as well, making the installation almost as
flexible as the Slackware installation.</p>


<h2>The Easy Installation CD</h2>

<p>The easy installation CD is a bootable CD, which boots a simple
linux system. Actually it is again a modified version of the slackware
first installation CD. This time all the packages are removed from it
and an image of the router harddisk is included, which will be just
copied physically to the new harddisk.</p>

<p>This copy of the image is done by the command
<strong>gateway-install</strong> (it may take some time until it is
finished). This command expects the blank harddisk to be the primary
master IDE (/dev/hda), and the CD-ROM drive to be the second master
IDE (/dev/hdc), otherwise it will not work (this is part of its
inflexibility). Basically it mounts the CD to a directory and then
uses a command similar to this to write it to the harddisk: 
<pre># dd if=/mnt/cdrom/gateway.img of=/dev/hda</pre>
</p>


<h2>Download</h2>

<p><a
href="http://sourceforge.net/project/showfiles.php?group_id=164743">Download
release files</a> or get the latest version from Subversion with a
command like this: 
<pre>$ svn checkout https://svn.sourceforge.net/svnroot/netaccess/scarlet/install</pre>
</p>
